<?php

namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Exception;

class ErpController extends \Zeedhi\Framework\Controller\Simple {

    protected $erpController;
    
    public function __construct(\Service\ErpService $erpService) {
        $this->erpService = $erpService;
    }

    public function consumirNotas(Request $request, Response $response) {
		
		try {
			$row = $request->getRow()[0];

			if(!empty($row)){
				if(empty($row['DTSAIDA'])) throw new \Exception('DTSAIDA deve ser informado.');
			}else{
				throw new \Exception('Nenhuma informação foi recebida.');
			}
			
			$notas = $this->erpService->consumirNotas($row);
			
			if(count($notas) > 0){
				$this->erpService->updateNotaEnviada($notas);
				$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('notas', $notas));
			}else{
				$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('notas', ['Nenhum registro encontrado!']));
			}
			
			$dataSet = array(
				'Status'	=> 'Retorno teste'
			);

		}catch(\Exception $e){
			$dataSet = array(
				'Status'	=> 'E',
				'Mensagem'  => $e->getMessage()
			);
			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('notas', $dataSet));
		}
	}
	
	public function desbloqueiaCancNF(Request $request, Response $response) {
		
		try {
			$row = $request->getRow()[0];

			if(!empty($row)){
				if(empty($row['CDFILIAL'])) throw new \Exception('CDFILIAL deve ser informado.');
				if(empty($row['NRLANCTONF'])) throw new \Exception('NRLANCTONF deve ser informado.');
			}else{
				throw new \Exception('Nenhuma informação foi recebida.');
			}
			
			$retorno = $this->erpService->desbloqueiaCancNF($row);

			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('notas', $retorno));

		}catch(\Exception $e){
			$dataSet = array(
				'Status'	=> 'E',
				'Mensagem'  => $e->getMessage()
			);
			$response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('notas', $dataSet));
		}
	}
	
}